// gmlTcl_Obj_Internal.h --
//
//    Internal declaration for the C implementation of gmlObject.
//
//  Copyright (c) 2007 LIG/IIHM
//
//  See the file "gml_LicenseTerms.txt" for information on usage and redistribution
//  of this file, and for a DISCLAIMER OF ALL WARRANTIES.
//
//  Created on June 28, 2007 (FB).

#ifndef __GMLTCL_OBJ_INTERNAL__
#define __GMLTCL_OBJ_INTERNAL__

#include "gml_List.h"

typedef enum {

  gmlTcl_kClassEntityType,
  gmlTcl_kObjectEntityType

} gmlTcl_TEntityType;

class gmlTcl_TEntity;
class gmlTcl_TObject;
class gmlTcl_TMethod;
class gmlTcl_TClass;




extern char*        gmlTcl_kEntityTypeStrings[];



Tcl_Interp*         gmlTcl_Obj_Interp              ();

int                 gmlTcl_Obj_UpdateStringNames   (char*               name,
                                                    char**              shortBuffer,
                                                    char**              protectedBuffer,
                                                    Tcl_Interp*         interp      = (Tcl_Interp*)NULL);

void                gmlTcl_Obj_AppendOptionList    (Tcl_Interp*         interp,
                                                    gml_TList*          methodList);

int                 gmlTcl_Obj_EntityListToStringNameObjList
                                                   (Tcl_Interp*         interp,
                                                    gml_TList*          list,
                                                    Tcl_Obj**           resObj,
                                                    int                 sorted      = 0);

int                 gmlTcl_Obj_HashToList          (Tcl_Interp*         interp,
                                                    Tcl_HashTable*      table,
                                                    gml_TList**         list,
                                                    gml_TListSortFunc*  sortFunc    = (gml_TListSortFunc*)NULL);

int                 gmlTcl_Obj_ListToObj           (Tcl_Interp*         interp,
                                                    gml_TList*          list,
                                                    Tcl_Obj**           resObj);

int                 gmlTcl_Obj_StringHashTableToObj(Tcl_Interp*         interp,
                                                    Tcl_HashTable*      table,
                                                    Tcl_Obj**           resObj,
                                                    int                 sorted      = 0);

gmlTcl_TEntity*     gmlTcl_Obj_EntityFromTclObj    (gmlTcl_TEntityType  type,
                                                    Tcl_Obj*            obj,
                                                    Tcl_Interp*         interp      = (Tcl_Interp*)NULL);
gmlTcl_TClass*      gmlTcl_Obj_ClassFromTclObj     (Tcl_Obj*            obj,
                                                    Tcl_Interp*         interp      = (Tcl_Interp*)NULL);
gmlTcl_TObject*     gmlTcl_Obj_ObjectFromTclObj    (Tcl_Obj*            obj,
                                                    Tcl_Interp*         interp      = (Tcl_Interp*)NULL);

Tcl_HashTable*      gmlTcl_Obj_EntityHashTable     (gmlTcl_TEntity*     theEntity);
void                gmlTcl_Obj_RegisterEntity      (gmlTcl_TEntity*     theEntity);
void                gmlTcl_Obj_DeregisterEntity    (gmlTcl_TEntity*     theEntity);

int                 gmlTcl_Obj_GlobalExists        (Tcl_Interp*         interp,
                                                    char*               varName,
                                                    int*                exists);

int                 gmlTcl_Obj_CloneGlobalArray    (Tcl_Interp*         interp,
                                                    char*               src,
                                                    char*               dst);

extern Tcl_Interp*         gmlTcl_gObj_Interp;
extern Tcl_HashTable       gmlTcl_gObj_ClassTable;
extern Tcl_HashTable       gmlTcl_gObj_ObjectTable;
extern gmlTcl_TClass*      gmlTcl_gObj_RootClass;


#endif
